# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python-learn
# FileName:      test_bpm.py
# Author:       xxxxxxx
# Datetime:     2023/8/8 10:32
# Description:
# 
# ---------------------------------------------------------------------------
import logging

import allure
import pytest

from My_APIAuto_demo.common.read_excel import ReadExcel


class TestBPM:
    @allure.epic("BPM系统")
    @pytest.mark.parametrize("module_name,interface_name,case_title,case_level,case_method,case_url,case_mime,case_data,expect_data,sql_type,sql_sentence,update_key",ReadExcel().get_data())
    def test_bpm(self,rep_fix,db_fix,module_name,interface_name,case_title,case_level,case_method,case_url,case_mime,case_data,expect_data,sql_type,sql_sentence,update_key):
        print([module_name,interface_name,case_title,case_level,case_method,case_url,case_mime,case_data,expect_data,sql_type,sql_sentence,update_key])
        allure.dynamic.feature(module_name)
        allure.dynamic.story(interface_name)
        allure.dynamic.title(case_title)
        allure.dynamic.severity(case_level)

        if sql_type == "delete":
            db_fix.delete(sql_sentence)

        elif sql_type == "select":
            select_result = db_fix.select(sql_sentence)
            case_data[update_key] = select_result

        elif sql_type == "select|delete" or sql_type == "delete|select":
            db_fix.delete(sql_sentence["delete"])
            select_result = db_fix.select(sql_sentence["select"])
            case_data[update_key] = select_result

        result = rep_fix.request_all(method=case_method,url=case_url,mime=case_mime,case_data=case_data)

        try:
            for key in expect_data:
                assert expect_data[key] == result.json().get(key)
        except:
            print("断言失败")
            logging.error(f"模块名：{module_name}，接口名：{interface_name}，期望结果：{expect_data}，实际返回结果：{result.text}")
            raise AssertionError("断言失败")
        else:
            print("断言成功")


if __name__ == '__main__':
    pytest.main()
